#!/usr/bin/perl

my $nicks_per_line  = 4;
my $max_nick_length = 12;

IRC::print("\cB\cC4BX-Names \cC7v1.1\cO by \cB\cC10Z\cC3irias\cO loading ...");

IRC::register("BX-Names","1.1","","");
IRC::add_message_handler("353","names_collect");
IRC::add_message_handler("366","names_print");
my @names_reply = ();
my $nicklen = 0;

sub names_collect {
  my $line = shift;
  $line =~ / :(.*)$/;
  @nickset = split(/ +/,$1);
  foreach (@nickset) {
    $nick = $_;
    if ($nicklen<length($nick)) {
      $nicklen=length($nick);
    }
    @names_reply = (@names_reply, $nick);
  }
  return 0;
}

sub names_print {
  if ($nicklen>$max_nick_length) {
    $nicklen=$max_nick_length;
  }
  $line = shift;
  $line =~ / ([^ ]*) :/;
  my $chan=$1;
  my $serv=IRC::get_info(3);
  my $list="";
  my $num=@names_reply;
  IRC::print_with_channel("\cC14[\cC9Users\cC14(\cC3$chan\cC14:\cC03$num\cC14)]",$chan,$serv);
  my $i=0;
  foreach (@names_reply) {
    /^([@+%!*])?(.*)$/;
    my $flag=sprintf("%-1s",$1);
    my $nick=sprintf("%-*s",$nicklen,$2);
    $list.="\cC14[\cC10$flag\cC12$nick \cC14] ";
    $i++;
    if ($i==$nicks_per_line) {
      IRC::print_with_channel($list,$chan,$serv);
      $list="";
      $i=0;
    }
  }
  if ($i>0) {
    IRC::print_with_channel($list,$chan,$serv);
  }
  @names_reply = ();
  $chanlen = 0;
  $nicklen = 0;
  return 1;
}

1;
#end
